{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% load widget_tweaks %}
{% load app_filters %}
{% load crispy_forms_tags %}
{% block content %}

<div class="d-flex" id="wrapper">

  <!-- Sidebar -->
  <div class="border-right border-dark bg-light search-wrapper" id="sidebar-wrapper">
    <div class='sidebar-heading'>Search</div>
      <form method="get" action='/search/' id='search-form'>
        <div id="div_id_q" class="form-group">
            <label for="id_q" class="">
                <a href='#' data-toggle="modal" data-target="#helpModal">
                    Query:
                </a>
            </label>
                <div class="">
                    <textarea name="q" cols="25" rows="2" maxlength="256" class="textarea form-control" id="id_q">{{q}}</textarea>                
                </div>  
        </div>
          <p>
              <label for="amount">Volume Date Range:</label>
              <input type="text" class='form-control' name='range' id="range" readonly style="background-color:lightgray">
            </p>
          <div id="slider-range" ></div>
          <hr/>

              <select name='language' class='form-control'>
                <option value="" {% if selected_language == '' %}selected{% endif %}>Any language</option>
                {% for language in languages %}
                  <option value="{{language}}" {% if language == selected_language %}selected{% endif %}>{{language|language_name}}</option>
                    {% endfor %}
                  </select>
          <hr/>
                  <select name='section_type' class='form-control'>
                    <option value="" {% if section_type == '' %}selected{% endif %}>Any section type</option>
                    {% for section_type in section_types %}
                      {% if section_type != None %}
                          <option value="{{section_type}}" {% if section_type == selected_section_type %}selected{% endif %}>{{section_type}}</option>
                      {% endif %}
                      {% endfor %}
                      </select>
                      <hr/>
                      <select name='feature' class='form-control'>
                        <option value="" {% if feature == '' %}selected{% endif %}>Any feature</option>
                        {% for feature in features %}
                          {% if feature != None %}
                            <option value="{{feature}}" {% if feature == selected_feature %}selected{% endif %}>{{feature}}</option>
                          {% endif %}
                          {% endfor %}
                        </select>
          

          <p>
<!--             <div class="form-check">
              <input type="checkbox" class="form-check-input" id="persons" value="organisations">
              <label class="form-check-label" for="persons">Persons</label>
            </div>
            <div class="form-check">
              <input type="checkbox" class="form-check-input" id="organisations" value="organisations">
              <label class="form-check-label" for="organisations">Organisations</label>
            </div>
            <div class="form-check">
              <input type="checkbox" class="form-check-input" id="places" value="places">
              <label class="form-check-label" for="places">Places</label>
            </div> -->
          </p>
          <button type="submit" class="btn btn-success btn-block"><i class="fas fa-search mr-2"></i>Search</button>
        </form>
        <hr/>
        {% if user.is_authenticated %}
        <div class='sidebar-heading' style='margin-top:-8px'> Batches</div>
        {% if batches.count > 0 %}
        <form>
          <div class='form-group'>
            <label>Current Batch:</label>
            <select class="form-control" id="current-batch">
              {% for batch in batches %}
                <option value="{{batch.id}}"
                {% if batch == current_batch %}selected="selected"{% endif %}>{{batch}}</option>
              {% endfor %}
            </select>
          </div>
          {% endif %}
      </form>
      {% endif %}
      {% if user.is_authenticated %}
        <form method='post' action='/batches/' target="_blank" style="margin-top:-30px">
          {{ batch_form.name|as_crispy_field }}
          {% csrf_token %}
          <input type='hidden' name='es_query' value='{{es_query}}'>
          <button type="submit" class="btn btn-primary btn-block">Create new batch</button>
        </form>
      {% endif %}

  </div>
  <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class="mt-3">
          {% if results_count > 0 %}
          <h3 class='text-center'>Search results</h3>  
            <h5 class='text-center'>{{ results_count }} pages found</h5>  
            {% if results.paginator.num_pages > 1 %}
              {% bootstrap_paginate results show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %}
            {% for result in results %}
              <hr/>
              <a class='text-small float-right mr-4 btn btn-sm btn-light' title="view image for this page" href="{{result.iiif_url}}" target="_blank" ><i class="fas fa-file-image mr-2"></i>View image</a>
                  
              <h5><a href="https://digilib.mpiwg-berlin.mpg.de/digitallibrary/jquery/digicat.html?fn=permanent/measuring_the_earth/{{result.volume.name}}" target="_blank">{{ result.volume.name }}</a> > {{ result.page_identifier }}</h5>
              <h6>{{ result.volume_metadata.title }}</h6>
                <p>
                {% for k,v in result.volume_metadata.to_dict.items %}
                    <span class='badge badge-secondary'>{{k}}: {{v}}</span>
                  {% endfor %}
                </p>
                <p>  
                  <span class="badge badge-secondary">language: {{result.language|language_name}} - score: {{result.language_confidence}}</span>
                  <span class="badge badge-secondary">section: {{result.section_type}}</span>
                  <span class="badge badge-secondary">feature: {{result.feature}}</span>
                  {% for key, value in result.metadata.to_dict.items %}
                  <span class="badge badge-secondary">{{key}}: {{value}}</span>
                </p>
              {% endfor %}
              {% if q %}
              {% endif %}
                {% if q %}
                  {{ result.meta.highlight.text.0|safe }}
                {% else %}
                  <p>{{ result.text }}</p>
                  <p>
                    <div class='btn-group'>
                    {% if current_batch %}
                    <a href='#' class='batch-add batch-button btn btn-sm btn-light' id="{{result.id}}" title="add page to current batch"><i class="fas fa-circle-notch fa-spin mr-2"></i> Add to current batch</a>
                    {% endif %}
                  </div>
                  </p>
              {% endif %}
            {% endfor %}
            {% if results.paginator.num_pages > 1 %}
              {% bootstrap_paginate results show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %}  
          {% else %}
            <div class="alert alert-primary">
              No results. Please try again!
            </div>
        {% endif %}
  </div>
</div>
    <script>

      function pagesInBatch(){
            $( ".batch-button" ).each(function(index, el) {
              var pageId = $(el).attr('id');
              $(el).html('<i class="fas fa-circle-notch fa-spin mr-2"></i>Loading');
              var batchId = $('#current-batch').val();
              var url = `/ajax/batches/${batchId}/page_in_batch/${pageId}`;
              $.ajax({url: url, context: el, success: function(result){
                if(result['in_batch']){
                  $(this).html('<i class="fas fa-folder-minus mr-2"></i>Remove from current batch');
                  $(this).removeClass('batch-add');
                  $(this).addClass('batch-remove');
                }
                else{
                  $(this).html('<i class="fas fa-folder-plus mr-2"></i>Add to current batch');
                  $(this).removeClass('batch-remove');
                  $(this).addClass('batch-add');                  
                }
              }});
          });
      }

      function submitOnEnter(event){
          if(event.which === 13){
              document.getElementById("search-form").submit();
              event.preventDefault();
          }
      }

      document.getElementById("id_q").addEventListener("keypress", submitOnEnter);

      $(document).ready(function() {
        var checked = $("input[type='checkbox']:checked").length;
        console.log(checked);
        if (checked == 0){ $("input[type='checkbox']").attr('checked','checked')};
  });
  
  $( function() {

    $(document).on('click', '.batch-button', function(e) {
      e.preventDefault();
      $(this).html('<i class="fas fa-circle-notch fa-spin mr-2"></i>Loading');
      var action = 'add';
      if($(this).hasClass('batch-remove')){
        action = 'remove';
      }
      var pageId = $(this).attr('id');
      var batchId = $('#current-batch').val();
      var url = `/ajax/batches/${batchId}/${action}_page/${pageId}`;
      $.ajax({url: url,context: this, success: function(result){
        if(action == 'add'){
          $(this).html('<i class="fas fa-folder-minus mr-2"></i> Remove from current batch');
          $(this).removeClass('batch-add');
          $(this).addClass('batch-remove');
        }else{
          $(this).html('<i class="fas fa-folder-plus mr-2"></i> Add to current batch');
          $(this).removeClass('batch-remove');
          $(this).addClass('batch-add');          
        }
      }});
    });

    $(document).on('change', '#current-batch', function(e) {
      e.preventDefault();
      var batchId = $(this).val();
      $.ajax({url: `/ajax/batches/${batchId}/set_current`,context: this, success: function(result){
          console.log(result)
      }});
      pagesInBatch();
    });

    pagesInBatch();

    $( "#slider-range" ).slider({
      range: true,
      min: {{first_year}},
    max: {{last_year}},
    values: [ {{first_bound}}, {{last_bound}} ],
    step: 1,
      slide: function( event, ui ) {
        $( "#range" ).val(  ui.values[0] + " - " + ui.values[1]  );
      }
    });
    $( "#range" ).val( $( "#slider-range" ).slider( "values", 0 ) +
      " - " + $( "#slider-range" ).slider( "values", 1 ) );
  } );
  </script>

<div class="modal fade" id="helpModal" tabindex="-1" role="dialog" aria-labelledby="helpModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Query Syntax</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
            <p>The following operators are supported:</p><div class="itemizedlist"><ul class="itemizedlist" type="disc"><li class="listitem"><code class="literal">+</code> signifies AND operation</li><li class="listitem"><code class="literal">|</code> signifies OR operation</li><li class="listitem"><code class="literal">-</code> negates a single token</li><li class="listitem"><code class="literal">"</code> wraps a number of tokens to signify a phrase for searching</li><li class="listitem"><code class="literal">*</code> at the end of a term signifies a prefix query</li><li class="listitem"><code class="literal">(</code> and <code class="literal">)</code> signify precedence</li><li class="listitem"><code class="literal">~N</code> after a word signifies edit distance (fuzziness)</li><li class="listitem"><code class="literal">~N</code> after a phrase signifies slop amount (the number of other words permitted between words)</li></ul></div><p>To use one of these characters literally, escape it with a preceding backslash
                (<code class="literal">\</code>).
            </p>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        </div>
      </div>
    </div>
  </div>
    {% endblock %}